package com.steerinfo.ems.emsprodplanroundweight.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.ems.emsprodplanroundweight.model.EmsProdplanRoundWeight;
import com.steerinfo.ems.emsprodplanroundweight.service.IEmsProdplanRoundWeightService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.ParseException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * EmsProdplanRoundWeight RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-12-01 04:14
 * 类描述
 * 修订历史：
 * 日期：2021-12-01
 * 作者：generator
 * 参考：
 * 描述：EmsProdplanRoundWeight RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/emsprodplanroundweights")
public class EmsProdplanRoundWeightController extends BaseRESTfulController {

    @Autowired
    IEmsProdplanRoundWeightService emsProdplanRoundWeightService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emsprodplanroundweight:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsProdplanRoundWeight> list = emsProdplanRoundWeightService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("emsprodplanroundweight:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<EmsProdplanRoundWeight> list = emsProdplanRoundWeightService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据EmsProdplanRoundWeight对象创建")
    @ApiImplicitParam(name = "emsProdplanRoundWeight", value = "详细实体emsProdplanRoundWeight", required = true, dataType = "EmsProdplanRoundWeight")
    //@RequiresPermissions("emsprodplanroundweight:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute EmsProdplanRoundWeight model){
        EmsProdplanRoundWeight emsProdplanRoundWeight = emsProdplanRoundWeightService.add(model);
        return success(emsProdplanRoundWeight);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("emsprodplanroundweight:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        EmsProdplanRoundWeight emsProdplanRoundWeight = emsProdplanRoundWeightService.getById(id);
        return success(emsProdplanRoundWeight);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的emsProdplanRoundWeight信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "emsProdplanRoundWeight", value = "详细实体emsProdplanRoundWeight", required = true, dataType = "EmsProdplanRoundWeight")
    })
    //@RequiresPermissions("emsprodplanroundweight:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody EmsProdplanRoundWeight model){
        model.setId(id);
        EmsProdplanRoundWeight emsProdplanRoundWeight = emsProdplanRoundWeightService.modify(model);
        return success(emsProdplanRoundWeight);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("emsprodplanroundweight:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  emsProdplanRoundWeightService.delete(ids);
    	}
      return success();
    }

}
