package com.steerinfo.ems.emssafeinfo.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;

@ApiModel(value="null")
public class EmsSafeinfo implements IBasePO<String> {
    @ApiModelProperty(value="",required=true)
    private String id;

    /**
     * 被查单位(PROCESS,VARCHAR,20)
     */
    @ApiModelProperty(value="被查单位",required=false)
    private String process;

    /**
     * 检查人(CREATEMAN,VARCHAR,10)
     */
    @ApiModelProperty(value="检查人",required=false)
    private String createman;

    /**
     * 检查时间(CREATETIME,VARCHAR,20)
     */
    @ApiModelProperty(value="检查时间",required=false)
    private String createtime;

    /**
     * 整改责任人(UPDATEMAN,VARCHAR,20)
     */
    @ApiModelProperty(value="整改责任人",required=false)
    private String updateman;

    /**
     * 整改期限(UPDATETIME,VARCHAR,20)
     */
    @ApiModelProperty(value="整改期限",required=false)
    private String updatetime;

    /**
     * 内容(CONTENT,VARCHAR,100)
     */
    @ApiModelProperty(value="内容",required=false)
    private String content;

    /**
     * 整改结果(FILENAME,VARCHAR,50)
     */
    @ApiModelProperty(value="整改结果",required=false)
    private String filename;

    /**
     * 类型(TYPE,VARCHAR,20)
     */
    @ApiModelProperty(value="类型",required=false)
    private String type;

    /**
     * 备注(MEMO,VARCHAR,100)
     */
    @ApiModelProperty(value="备注",required=false)
    private String memo;

    /**
     * 日期(DATES,VARCHAR,20)
     */
    @ApiModelProperty(value="日期",required=false)
    private String dates;

    /**
     * 整改日期(RECTIFICATIONDATE,VARCHAR,20)
     */
    @ApiModelProperty(value="整改日期",required=false)
    private String rectificationdate;

    /**
     * 验证人(VERIFY,VARCHAR,20)
     */
    @ApiModelProperty(value="验证人",required=false)
    private String verify;

    /**
     * 资金(MONEY,DECIMAL,0)
     */
    @ApiModelProperty(value="资金",required=false)
    private BigDecimal money;

    /**
     * 预案(PLAN,VARCHAR,200)
     */
    @ApiModelProperty(value="预案",required=false)
    private String plan;

    /**
     * 隐患分级(HAZARD,VARCHAR,10)
     */
    @ApiModelProperty(value="隐患分级",required=false)
    private String hazard;

    /**
     * 整改措施(MEASURE,VARCHAR,200)
     */
    @ApiModelProperty(value="整改措施",required=false)
    private String measure;

    private static final long serialVersionUID = 1L;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id == null ? null : id.trim();
    }

    public String getProcess() {
        return process;
    }

    public void setProcess(String process) {
        this.process = process == null ? null : process.trim();
    }

    public String getCreateman() {
        return createman;
    }

    public void setCreateman(String createman) {
        this.createman = createman == null ? null : createman.trim();
    }

    public String getCreatetime() {
        return createtime;
    }

    public void setCreatetime(String createtime) {
        this.createtime = createtime == null ? null : createtime.trim();
    }

    public String getUpdateman() {
        return updateman;
    }

    public void setUpdateman(String updateman) {
        this.updateman = updateman == null ? null : updateman.trim();
    }

    public String getUpdatetime() {
        return updatetime;
    }

    public void setUpdatetime(String updatetime) {
        this.updatetime = updatetime == null ? null : updatetime.trim();
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content == null ? null : content.trim();
    }

    public String getFilename() {
        return filename;
    }

    public void setFilename(String filename) {
        this.filename = filename == null ? null : filename.trim();
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type == null ? null : type.trim();
    }

    public String getMemo() {
        return memo;
    }

    public void setMemo(String memo) {
        this.memo = memo == null ? null : memo.trim();
    }

    public String getDates() {
        return dates;
    }

    public void setDates(String dates) {
        this.dates = dates == null ? null : dates.trim();
    }

    public String getRectificationdate() {
        return rectificationdate;
    }

    public void setRectificationdate(String rectificationdate) {
        this.rectificationdate = rectificationdate == null ? null : rectificationdate.trim();
    }

    public String getVerify() {
        return verify;
    }

    public void setVerify(String verify) {
        this.verify = verify == null ? null : verify.trim();
    }

    public BigDecimal getMoney() {
        return money;
    }

    public void setMoney(BigDecimal money) {
        this.money = money;
    }

    public String getPlan() {
        return plan;
    }

    public void setPlan(String plan) {
        this.plan = plan == null ? null : plan.trim();
    }

    public String getHazard() {
        return hazard;
    }

    public void setHazard(String hazard) {
        this.hazard = hazard == null ? null : hazard.trim();
    }

    public String getMeasure() {
        return measure;
    }

    public void setMeasure(String measure) {
        this.measure = measure == null ? null : measure.trim();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", id=").append(id);
        sb.append(", process=").append(process);
        sb.append(", createman=").append(createman);
        sb.append(", createtime=").append(createtime);
        sb.append(", updateman=").append(updateman);
        sb.append(", updatetime=").append(updatetime);
        sb.append(", content=").append(content);
        sb.append(", filename=").append(filename);
        sb.append(", type=").append(type);
        sb.append(", memo=").append(memo);
        sb.append(", dates=").append(dates);
        sb.append(", rectificationdate=").append(rectificationdate);
        sb.append(", verify=").append(verify);
        sb.append(", money=").append(money);
        sb.append(", plan=").append(plan);
        sb.append(", hazard=").append(hazard);
        sb.append(", measure=").append(measure);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}